﻿Imports System.Diagnostics

Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Text = AppTitleAndVersion()
        '
        FileName = "LogFile.csv"
        Load_INI()
        InitFileName()
        '
        LoadSlotNames()
        '
        CHK_Run.Focus()
        '
        SetRunButtonDefaultText()
        If CHK_Run.Checked Then StartRun()
        '
        Timer1.Interval = 50
        Timer1.Start()
        '
        EventsAreEnabled = True
        '
        Me.Refresh()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        StopRun()
        Save_INI()
    End Sub

    ' ==============================================================================================================
    '  RUN and STOP
    ' ==============================================================================================================
    Private Sub CHK_Run_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CHK_Run.CheckedChanged
        If Not EventsAreEnabled Then Return
        If CHK_Run.Checked Then
            StartRun()
        Else
            StopRun()
        End If
    End Sub

    Private Sub InitFileName()
        FileName = TXT_LogFileName.Text
        FileName = Application.StartupPath + "\LOGS\" + FileName
    End Sub

    Private Sub StartRun()
        SetRunButtonDefaultText()
        TXT_LogFileName.Enabled = False
        TXT_CommandsSlot.Enabled = False
        TXT_Interval.Enabled = False
        CHK_BackupLogFiles.Enabled = False
        CHK_AddHeadingText.Enabled = False
        CHK_DateAndTime.Enabled = False
        CHK_JulianDate.Enabled = False
        If CHK_BackupLogFiles.Checked And IO.File.Exists(FileName) Then
            BackupLogFile()
        End If
        InitLogFile()
        SetFastTimer_Interval()
        FastTimer_Start()
    End Sub

    Private Sub StopRun()
        FastTimer_Stop()
        If CHK_BackupLogFiles.Checked And IO.File.Exists(FileName) Then
            BackupLogFile()
        End If
        TXT_LogFileName.Enabled = True
        TXT_CommandsSlot.Enabled = True
        TXT_Interval.Enabled = True
        CHK_BackupLogFiles.Enabled = True
        CHK_AddHeadingText.Enabled = True
        CHK_DateAndTime.Enabled = True
        CHK_JulianDate.Enabled = True
        SetRunButtonDefaultText()
    End Sub

    Friend Sub SetRunButtonDefaultText()
        CHK_Run.Text = "R U N"
    End Sub

    Private Sub InitLogFile()
        Dim s As String = ""
        If CHK_AddHeadingText.Checked Then
            ' ----------------------------------------------------- If the "_Heading_Text_.txt" file exists then add HEADING TEXT
            Dim f As String
            f = Application.StartupPath + "\LOGS\_Heading_Text_.txt"
            If IO.File.Exists(f) Then
                s = IO.File.ReadAllText(f)
            End If
            ' ----------------------------------------------------- Add Date and Time
            If AddDateAndTime Then
                s += "Date Time and Millisecs" + FieldSeparator
            End If
            ' ----------------------------------------------------- Add OA date or Julian date
            If AddJulianDate Then
                's += "OADate          " + FieldSeparator
                s += "JulianDate      " + FieldSeparator
            End If
            ' ----------------------------------------------------- Add SlotName fields
            For i As Int32 = FirstSlot To FirstSlot + NumSlots - 1
                If SlotNames(i) IsNot Nothing Then
                    s += SlotNames(i).PadRight(10) + FieldSeparator
                End If
            Next
            ' ----------------------------------------------------- Remove the last separator
            If s <> "" Then s = Strings.Left(s, s.Length - 1)
        End If
        ' --------------------------------------------------------- Add separator
        s += vbCrLf + StrDup(80, "-") + "START"
        ' --------------------------------------------------------- Init LogFile name
        If TXT_LogFileName.Text = "" Then
            TXT_LogFileName.Text = "LogFile.csv"
            InitFileName()
        End If
        ' --------------------------------------------------------- Init LogFile eventually with the first line
        IO.Directory.CreateDirectory(IO.Path.GetDirectoryName(FileName))
        Dim file As System.IO.StreamWriter
        file = My.Computer.FileSystem.OpenTextFileWriter(FileName, _
                                                         False, _
                                                         New System.Text.ASCIIEncoding())
        file.WriteLine(s)
        file.Close()
        ' --------------------------------------------------------- Set the Creation-Time
        IO.File.SetCreationTime(FileName, Now)
    End Sub

    Private Sub SetFastTimer_Interval()
        Dim n As Int32 = CInt(Val(TXT_Interval.Text) * 1000)
        If n <= 0 Then n = 1
        FastTimerMillisec = n
    End Sub

    ' ==============================================================================================================
    '  UPPER BAR CONTROLS
    ' ==============================================================================================================
    Private Sub BTN_OpenFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_OpenFile.Click
        On Error Resume Next
        Process.Start(FileName)
    End Sub
    Private Sub BTN_OpenFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_OpenFolder.Click
        IO.Directory.CreateDirectory(IO.Path.GetDirectoryName(FileName))
        Process.Start(IO.Path.GetDirectoryName(FileName))
    End Sub
    Private Sub BTN_EditHeadingText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_EditHeadingText.Click
        Dim f As String = Application.StartupPath + "\LOGS\_Heading_Text_.txt"
        If Not IO.File.Exists(f) Then
            Dim str As String = ""
            str += "=================================================================" + vbCrLf
            str += "HEADING TEXT EXAMPLE" + vbCrLf
            str += "-----------------------------------------------------------------" + vbCrLf
            str += "IF YOU WRITE SOMETHING IN THIS FILE" + vbCrLf
            str += "THEN IT WILL APPEAR IN THE HEADING OF EACH FILE" + vbCrLf
            str += "================================================================="
            IO.File.WriteAllText(f, Str, System.Text.Encoding.UTF8)
        End If
        Process.Start(f)
    End Sub

    Private Sub TXT_LogFileName_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TXT_LogFileName.TextChanged
        If Not EventsAreEnabled Then Return
        InitFileName()
        Save_INI()
    End Sub
    Private Sub CHK_BackupLogFiles_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CHK_BackupLogFiles.CheckedChanged
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub
    Private Sub CHK_AddFirstLine_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CHK_AddHeadingText.CheckedChanged
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub
    Private Sub CHK_DateAndTime_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CHK_DateAndTime.CheckedChanged
        AddDateAndTime = CHK_DateAndTime.Checked
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub
    Private Sub CHK_JulianDate_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CHK_JulianDate.CheckedChanged
        AddJulianDate = CHK_JulianDate.Checked
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    Private Sub TXT_ADC24Gain_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TXT_ADC24Gain.TextChanged
        Divider = CInt(Val(TXT_ADC24Gain.Text))
    End Sub

    Private Sub TXT_FirstSlot_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TXT_FirstSlot.TextChanged
        FirstSlot = CInt(Val(TXT_FirstSlot.Text))
    End Sub

    Private Sub TXT_NumSlots_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TXT_NumSlots.TextChanged
        NumSlots = CInt(Val(TXT_NumSlots.Text))
    End Sub

    Private Sub TXT_CommandsSlot_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TXT_CommandsSlot.TextChanged
        CommandsSlot = TXT_CommandsSlot.NumericValueInteger
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    Private Sub TXT_Interval_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TXT_Interval.TextChanged
        SetFastTimer_Interval()
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub
    

    ' ==============================================================================================================
    '  TIMER
    ' ==============================================================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        '
        ' ----------------------------------------------------- Poll the TEXT COMMANDS SLOT
        PollTextCommandsSlot()
        ' ----------------------------------------------------- Test SlotFile and reload it if changed
        TestSlotFile()
    End Sub

End Class
