﻿Module Module_DataLogger

    Friend FieldSeparator As String = ";"
    Friend GCI As Globalization.CultureInfo = Globalization.CultureInfo.InvariantCulture
    Friend FileName As String
    Friend AddDateAndTime As Boolean
    Friend AddJulianDate As Boolean
    Friend LogLine As String

    Friend Divider As Int32 = 1
    Friend FirstSlot As Int32
    Friend NumSlots As Int32

    Friend Sub BackupLogFile()
        Dim BackupFname As String = ""
        BackupFname += Application.StartupPath + "\LOGS\" + IO.Path.GetFileNameWithoutExtension(FileName) + "__"
        BackupFname += IO.File.GetCreationTime(FileName).ToString("yyyy_MM_dd__HH_mm_ss", GCI)
        BackupFname += IO.Path.GetExtension(FileName)
        IO.File.Copy(FileName, BackupFname, True)
    End Sub

    Friend Sub DataLogger_Tick()
        ' ----------------------------------------------------- Create log-line
        LogLine = ""
        Dim d As Date = Date.Now
        ' ----------------------------------------------------- Add Date and Time
        If AddDateAndTime Then
            LogLine += d.ToString("yyyy/MM/dd HH:mm:ss.fff", GCI) + FieldSeparator
        End If
        ' ----------------------------------------------------- Add OA date or Julian date
        If AddJulianDate Then
            'LogLine += DateToOADate(d) + FieldSeparator
            LogLine += DateToJulianDate(d) + FieldSeparator
        End If
        ' ----------------------------------------------------- Add log fields
        For i As Int32 = FirstSlot To FirstSlot + NumSlots - 1
            LogLine += (Slots.ReadSlot(i) / Divider).ToString("0.000", GCI) + FieldSeparator
        Next
        ' ----------------------------------------------------- Remove the last separator
        If LogLine <> "" Then
            LogLine = Left(LogLine, LogLine.Length - 1)
        End If
        ' ----------------------------------------------------- Write log-line to file
        Try
            Dim file As System.IO.StreamWriter
            file = My.Computer.FileSystem.OpenTextFileWriter(FileName, _
                                                             True, _
                                                             New System.Text.ASCIIEncoding())
            file.WriteLine(LogLine)
            file.Close()
        Catch
        End Try
    End Sub

    ' =======================================================================
    '  Date to OLE Automation date
    ' =======================================================================
    Public Function DateToOADate(ByVal dt As Date) As String
        Return dt.ToOADate.ToString("0.00000000", GCI)
    End Function

    ' =======================================================================
    '  Date to true Julian date
    ' =======================================================================
    '  OADate = number of days since midnight on the 31st December 1899
    '  Julian = number of days since midday on the 1st of January, 4713 BC
    '  2415018.5 = difference between the two dates
    ' =======================================================================
    Public Function DateToJulianDate(ByVal d As Date) As String
        Return (d.ToOADate + 2415018.5).ToString("0.00000000", GCI)
    End Function

End Module
